/* Treatout to use with newer MINMAX format ! */
/* Thomas Sourmail, Cambridge University, 2001 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int main(int argc, char *argv[])
{
  FILE *ifp,*ofp;
  int no_of_lines,no_of_columns,no_of_models,i,j;
  float min[50],max[50],x1[50],x2,x3,x4,x5,result,dummy,mean,stdev;
  char data_file[50],minmax_file[50],c;
  
  if(argc == 3) 
    {
      printf("\n\n%s ","You have not specified the name of the minmax and data files\n");
      printf("%s\n","Using MINMAX and nn-output_b by default");
      /* Line that can be amended for MINMAX file */
      strcpy(minmax_file,"../input/MINMAX");
      /* Line that can be amended for file of mormalised inputs*/
      strcpy(data_file,"nn-output_b");
    }
  if(argc == 5) 
    {
      strcpy(minmax_file,argv[3]);
      strcpy(data_file,argv[4]);
    }
  
  if(argc != 3 && argc != 5)
    {;
    printf("\n\n%s %s %s\n\n","Usage:",argv[0],"no_of_lines no_of_input_variables Min_Max_file Data_file");
    printf("%s %s %s\n\n","or",argv[0],"no_of_lines no_of_input_variables");
    exit(0);
    }
  
  no_of_lines=atoi(argv[1]);
  no_of_columns=atoi(argv[2]);
  printf("%d %d %s\n",no_of_lines,no_of_columns,minmax_file);
  
  if((ifp=fopen(minmax_file,"r")) == NULL) 
    {
      printf("Error in %s: unable to find file %s\n",argv[0],minmax_file);
      exit(0);
    }
  else {
    while((c=getc(ifp)) != '\n');
    
    for(i=1;i<=no_of_columns;++i) {
      fscanf(ifp,"%f%f%f%f%f%f",&min[i],&max[i],&dummy,&dummy,&dummy,&dummy);
      printf("Printing here : \t%d : %f %f %f %f %f %f\n",i,min[i],max[i],dummy,dummy,dummy,dummy);
    }
    
    fclose(ifp);
  }
  /* Line that can be amended */
  if((ifp=fopen("nn-output_b","r")) == NULL || (ofp=fopen("result","w")) == NULL)
    {
      printf("Error in %s: unable to find file %s\n",argv[0],data_file);
      printf("or to create result file\n");
      exit(0);
    } 
  else 
    {
      i=0;
      j=0;
      {
	/* Line that can be amended acccording to input variable names*/
	fprintf(ofp,"%s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\t\t %s\n",
			"C","Mn","Si","P","S","Cr","Ni","Mo","Ti","Nb","V","Al","N","B","Cu","FRT","CT","Result","Error");
	
	{
	  for(j=1;j <= no_of_lines;j++)
	    {
	      for (i=1; i<no_of_columns;i++)
		{
		  fscanf(ifp,"%f ",&x1[i]);
		  printf("\tRead %d %d : %f",j,i,x1[i]);
		  printf("\tmax %f min %f\n",max[i],min[i]);		
		  x1[i]=((x1[i]+0.5)*(max[i]-min[i]))+min[i];
		  fprintf(ofp,"%f\t ",x1[i]);
		  
		}
	      
		{
		  i=no_of_columns;		
		  fscanf(ifp,"%f ",&x1[i]);
		  x1[i]=(((x1[i]+0.5)*(max[i-1]-min[i-1])+min[i-1])-x1[no_of_columns-1]);
		  fprintf(ofp,"%f\t ",x1[i]);
		}
      
		fprintf(ofp,"\n");
		printf("\n");
	      }
	  
	  fclose(ifp);
	  fclose(ofp);
	}
      }
    }
}
